"use strict";
var api = require("../api");
var _API_ROOT = "/v1beta1/";
var _listCollectionIds = function (project) {
    var url = _API_ROOT + "projects/" + project + "/databases/(default)/documents:listCollectionIds";
    return api
        .request("POST", url, {
        auth: true,
        origin: api.firestoreOrigin,
        data: {
            pageSize: 2147483647,
        },
    })
        .then(function (res) {
        return res.body.collectionIds || [];
    });
};
var _deleteDocument = function (doc) {
    return api.request("DELETE", _API_ROOT + doc.name, {
        auth: true,
        origin: api.firestoreOrigin,
    });
};
var _deleteDocuments = function (project, docs) {
    var parent = "projects/" + project + "/databases/(default)/documents";
    var url = parent + ":commit";
    var writes = docs.map(function (doc) {
        return {
            delete: doc.name,
        };
    });
    var body = {
        writes: writes,
    };
    return api
        .request("POST", _API_ROOT + url, {
        auth: true,
        data: body,
        origin: api.firestoreOrigin,
    })
        .then(function (res) {
        return res.body.writeResults.length;
    });
};
module.exports = {
    deleteDocument: _deleteDocument,
    deleteDocuments: _deleteDocuments,
    listCollectionIds: _listCollectionIds,
};
//# sourceMappingURL=firestore.js.map